--- old/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
+++ new/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
@@ -21748,7 +21753,7 @@
 	ucmd_buf.uscsi_rqbuf	= (caddr_t)&sense_buf;
 	ucmd_buf.uscsi_rqlen	= sizeof (struct scsi_extended_sense);
 	ucmd_buf.uscsi_flags	= USCSI_RQENABLE | USCSI_WRITE | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 60;
+	ucmd_buf.uscsi_timeout	= un->un_uscsi_timeout;
 
 	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL,
 	    UIO_SYSSPACE, path_flag);
@@ -21886,7 +21891,7 @@
 	ucmd_buf.uscsi_rqbuf	= (caddr_t)&sense_buf;
 	ucmd_buf.uscsi_rqlen	= sizeof (struct scsi_extended_sense);
 	ucmd_buf.uscsi_flags	= flag | USCSI_RQENABLE | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 60;
+	ucmd_buf.uscsi_timeout	= un->un_cmd_timeout;
 	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL,
 	    UIO_SYSSPACE, path_flag);
 
@@ -21966,7 +21971,7 @@
 	ucmd_buf.uscsi_rqbuf	= (caddr_t)&sense_buf;
 	ucmd_buf.uscsi_rqlen	= sizeof (struct scsi_extended_sense);
 	ucmd_buf.uscsi_flags	= USCSI_RQENABLE | USCSI_READ | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 60;
+	ucmd_buf.uscsi_timeout	= un->un_uscsi_timeout;
 
 	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL,
 	    UIO_SYSSPACE, path_flag);
@@ -22098,7 +22103,7 @@
 	ucmd_buf.uscsi_rqbuf	= NULL;
 	ucmd_buf.uscsi_rqlen	= 0;
 	ucmd_buf.uscsi_flags	= USCSI_READ | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 60;
+	ucmd_buf.uscsi_timeout	= un->un_uscsi_timeout;
 
 	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL,
 	    UIO_SYSSPACE, SD_PATH_DIRECT);
@@ -22180,11 +22185,6 @@
 
 	ASSERT(!mutex_owned(SD_MUTEX(un)));
 
-	/* Initialize sd_ssc_t for internal uscsi commands */
-	ssc = sd_ssc_init(un);
-
-	is_valid = SD_IS_VALID_LABEL(un);
-
 	/*
 	 * Moved this wait from sd_uscsi_strategy to here for
 	 * reasons of deadlock prevention. Internal driver commands,
@@ -22193,9 +22193,18 @@
 	 */
 	mutex_enter(SD_MUTEX(un));
 	while ((un->un_state == SD_STATE_SUSPENDED) ||
-	    (un->un_state == SD_STATE_PM_CHANGING)) {
+	    (un->un_state == SD_STATE_PM_CHANGING) ||
+	    (un->un_state == SD_STATE_ATTACHING)) {
 		cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
 	}
+
+	if (un->un_state == SD_STATE_ATTACH_FAILED) {
+		mutex_exit(SD_MUTEX(un));
+		SD_ERROR(SD_LOG_READ_WRITE, un,
+		    "sdioctl: attach failed\n");
+		return (EIO);
+	}
+
 	/*
 	 * Twiddling the counter here protects commands from now
 	 * through to the top of sd_uscsi_strategy. Without the
@@ -22205,7 +22214,15 @@
 	 * That would cause problems.
 	 */
 	un->un_ncmds_in_driver++;
+	mutex_exit(SD_MUTEX(un));
 
+	/* Initialize sd_ssc_t for internal uscsi commands */
+	ssc = sd_ssc_init(un);
+
+	is_valid = SD_IS_VALID_LABEL(un);
+
+	mutex_enter(SD_MUTEX(un));
+
 	if (!is_valid &&
 	    (flag & (FNDELAY | FNONBLOCK))) {
 		switch (cmd) {
@@ -22226,12 +22243,9 @@
 		case DKIOCSMBOOT:
 		case DKIOCG_PHYGEOM:
 		case DKIOCG_VIRTGEOM:
-#if defined(__i386) || defined(__amd64)
 		case DKIOCSETEXTPART:
-#endif
 			/* let cmlb handle it */
 			goto skip_ready_valid;
-
 		case CDROMPAUSE:
 		case CDROMRESUME:
 		case CDROMPLAYMSF:
@@ -22255,6 +22269,8 @@
 			if (!ISCD(un)) {
 				un->un_ncmds_in_driver--;
 				ASSERT(un->un_ncmds_in_driver >= 0);
+				if (un->un_f_detach_waiting)
+					cv_signal(&un->un_detach_cv);
 				mutex_exit(SD_MUTEX(un));
 				err = ENOTTY;
 				goto done_without_assess;
@@ -22266,6 +22282,8 @@
 			if (!un->un_f_eject_media_supported) {
 				un->un_ncmds_in_driver--;
 				ASSERT(un->un_ncmds_in_driver >= 0);
+				if (un->un_f_detach_waiting)
+					cv_signal(&un->un_detach_cv);
 				mutex_exit(SD_MUTEX(un));
 				err = ENOTTY;
 				goto done_without_assess;
@@ -22278,6 +22296,8 @@
 				mutex_enter(SD_MUTEX(un));
 				un->un_ncmds_in_driver--;
 				ASSERT(un->un_ncmds_in_driver >= 0);
+				if (un->un_f_detach_waiting)
+					cv_signal(&un->un_detach_cv);
 				mutex_exit(SD_MUTEX(un));
 				err = EIO;
 				goto done_quick_assess;
@@ -22336,6 +22356,8 @@
 				}
 				un->un_ncmds_in_driver--;
 				ASSERT(un->un_ncmds_in_driver >= 0);
+				if (un->un_f_detach_waiting)
+					cv_signal(&un->un_detach_cv);
 				mutex_exit(SD_MUTEX(un));
 
 				goto done_without_assess;
@@ -22379,9 +22401,7 @@
 	case DKIOCSMBOOT:
 	case DKIOCG_PHYGEOM:
 	case DKIOCG_VIRTGEOM:
-#if defined(__i386) || defined(__amd64)
 	case DKIOCSETEXTPART:
-#endif
 		SD_TRACE(SD_LOG_IOCTL, un, "DKIOC %d\n", cmd);
 
 		/* TUR should spin up */
@@ -22760,14 +22780,10 @@
 
 	case CDROMPLAYTRKIND:
 		SD_TRACE(SD_LOG_IOCTL, un, "CDROMPLAYTRKIND\n");
-#if defined(__i386) || defined(__amd64)
 		/*
 		 * not supported on ATAPI CD drives, use CDROMPLAYMSF instead
 		 */
 		if (!ISCD(un) || (un->un_f_cfg_is_atapi == TRUE)) {
-#else
-		if (!ISCD(un)) {
-#endif
 			err = ENOTTY;
 		} else {
 			err = sr_play_trkind(dev, (caddr_t)arg, flag);
@@ -23058,11 +23074,11 @@
 	case SDIOCPUSH:
 	case SDIOCRETRIEVE:
 	case SDIOCRUN:
+	case SDIOCINSERTTRAN:
 		SD_INFO(SD_LOG_SDTEST, un, "sdioctl:"
 		    "SDIOC detected cmd:0x%X:\n", cmd);
 		/* call error generator */
-		sd_faultinjection_ioctl(cmd, arg, un);
-		err = 0;
+		err = sd_faultinjection_ioctl(cmd, arg, un);
 		break;
 
 #endif /* SD_FAULT_INJECTION */
@@ -23103,6 +23119,20 @@
 		}
 		break;
 
+	case DKIOCFREE:
+		{
+			dkioc_free_list_t *dfl = (dkioc_free_list_t *)arg;
+
+			/* bad userspace ioctls shouldn't panic */
+			if (dfl == NULL && !(flag & FKIOCTL)) {
+				err = SET_ERROR(EINVAL);
+				break;
+			}
+			/* synchronous UNMAP request */
+			err = sd_send_scsi_UNMAP(dev, ssc, dfl, flag);
+		}
+		break;
+
 	case DKIOCGETWCE: {
 
 		int wce;
@@ -23248,6 +23278,8 @@
 	mutex_enter(SD_MUTEX(un));
 	un->un_ncmds_in_driver--;
 	ASSERT(un->un_ncmds_in_driver >= 0);
+	if (un->un_f_detach_waiting)
+		cv_signal(&un->un_detach_cv);
 	mutex_exit(SD_MUTEX(un));
 
 
@@ -23261,6 +23293,8 @@
 	mutex_enter(SD_MUTEX(un));
 	un->un_ncmds_in_driver--;
 	ASSERT(un->un_ncmds_in_driver >= 0);
+	if (un->un_f_detach_waiting)
+		cv_signal(&un->un_detach_cv);
 	mutex_exit(SD_MUTEX(un));
 
 done_quick_assess:
@@ -23365,7 +23399,7 @@
  *		dki_pbsize	- physical block size (if requested)
  *
  * Return Code: 0
- *		EACCESS
+ *		EACCES
  *		EFAULT
  *		ENXIO
  *		EIO
@@ -23483,11 +23517,10 @@
 		rval = sd_send_scsi_READ_CAPACITY_16(ssc, &capacity, &lbasize,
 		    &pbsize, SD_PATH_DIRECT);
 
-		/*
-		 * Override the physical blocksize if the instance already
-		 * has a larger value.
-		 */
-		pbsize = MAX(pbsize, un->un_phy_blocksize);
+		if (un->un_f_sdconf_phy_blocksize) /* keep sd.conf's pbs */
+			pbsize = un->un_phy_blocksize;
+		else /* override the pbs if the instance has a larger value */
+			pbsize = MAX(pbsize, un->un_phy_blocksize);
 	}
 
 	if (dki_pbsize == NULL || rval != 0 ||
@@ -23747,6 +23780,8 @@
 		 */
 		un->un_ncmds_in_driver--;
 		ASSERT(un->un_ncmds_in_driver >= 0);
+		if (un->un_f_detach_waiting)
+			cv_signal(&un->un_detach_cv);
 
 		/*
 		 * if a prior request had been made, this will be the same
@@ -24240,7 +24275,7 @@
  *		0  - log page not found.
  *  		1  - log page found.
  */
-
+#ifdef notyet
 static int
 sd_log_page_supported(sd_ssc_t *ssc, int log_page)
 {
@@ -24305,8 +24340,8 @@
 	kmem_free(log_page_data, 0xFF);
 	return (match);
 }
+#endif
 
-
 /*
  *    Function: sd_mhdioc_failfast
  *
@@ -25742,12 +25777,12 @@
 
 	instance = SDUNIT(dev);
 	if (((un = ddi_get_soft_state(sd_state, instance)) == NULL) ||
+	    (un->un_state == SD_STATE_ATTACHING) ||
+	    (un->un_state == SD_STATE_ATTACH_FAILED) ||
 	    !SD_IS_VALID_LABEL(un) || ISCD(un)) {
 		return (ENXIO);
 	}
 
-	_NOTE(NOW_INVISIBLE_TO_OTHER_THREADS(*un))
-
 	SD_TRACE(SD_LOG_DUMP, un, "sddump: entry\n");
 
 	partition = SDPART(dev);
@@ -27991,7 +28026,7 @@
 	com->uscsi_cdblen  = CDB_GROUP1;
 	com->uscsi_bufaddr = buffer;
 	com->uscsi_buflen  = 0x04;
-	com->uscsi_timeout = 300;
+	com->uscsi_timeout = 3 * un->un_cmd_timeout;
 	com->uscsi_flags   = USCSI_DIAGNOSE|USCSI_SILENT|USCSI_READ;
 
 	rval = sd_send_scsi_cmd(dev, com, FKIOCTL, UIO_SYSSPACE,
@@ -29340,8 +29375,6 @@
 				    KM_NOSLEEP);
 			if (wmp == NULL) {
 				mutex_exit(SD_MUTEX(un));
-				_NOTE(DATA_READABLE_WITHOUT_LOCK
-				    (sd_lun::un_wm_cache))
 				wmp = kmem_cache_alloc(un->un_wm_cache,
 				    KM_SLEEP);
 				mutex_enter(SD_MUTEX(un));
@@ -29740,7 +29773,7 @@
  */
 
 static void
-sd_failfast_flushq(struct sd_lun *un)
+sd_failfast_flushq(struct sd_lun *un, boolean_t flush_all)
 {
 	struct buf *bp;
 	struct buf *next_waitq_bp;
@@ -29758,7 +29791,8 @@
 	 * Check if we should flush all bufs when entering failfast state, or
 	 * just those with B_FAILFAST set.
 	 */
-	if (sd_failfast_flushctl & SD_FAILFAST_FLUSH_ALL_BUFS) {
+	if ((sd_failfast_flushctl & SD_FAILFAST_FLUSH_ALL_BUFS) ||
+	    flush_all) {
 		/*
 		 * Move *all* bp's on the wait queue to the failfast flush
 		 * queue, including those that do NOT have B_FAILFAST set.
@@ -30018,7 +30052,6 @@
  */
 
 #ifdef SD_FAULT_INJECTION
-static uint_t   sd_fault_injection_on = 0;
 
 /*
  *    Function: sd_faultinjection_ioctl()
@@ -30031,11 +30064,12 @@
  *		arg	- the arguments from user and returns
  */
 
-static void
-sd_faultinjection_ioctl(int cmd, intptr_t arg,  struct sd_lun *un)
+static int
+sd_faultinjection_ioctl(int cmd, intptr_t arg, struct sd_lun *un)
 {
 	uint_t i = 0;
 	uint_t rval;
+	int ret = 0;
 
 	SD_TRACE(SD_LOG_IOERR, un, "sd_faultinjection_ioctl: entry\n");
 
@@ -30065,6 +30099,7 @@
 			un->sd_fi_fifo_xb[i] = NULL;
 			un->sd_fi_fifo_un[i] = NULL;
 			un->sd_fi_fifo_arq[i] = NULL;
+			un->sd_fi_fifo_tran[i] = NULL;
 		}
 		un->sd_fi_fifo_start = 0;
 		un->sd_fi_fifo_end = 0;
@@ -30103,10 +30138,15 @@
 				kmem_free(un->sd_fi_fifo_arq[i],
 				    sizeof (struct sd_fi_arq));
 			}
+			if (un->sd_fi_fifo_tran[i] != NULL) {
+				kmem_free(un->sd_fi_fifo_tran[i],
+				    sizeof (struct sd_fi_tran));
+			}
 			un->sd_fi_fifo_pkt[i] = NULL;
 			un->sd_fi_fifo_un[i] = NULL;
 			un->sd_fi_fifo_xb[i] = NULL;
 			un->sd_fi_fifo_arq[i] = NULL;
+			un->sd_fi_fifo_tran[i] = NULL;
 		}
 		un->sd_fi_fifo_start = 0;
 		un->sd_fi_fifo_end = 0;
@@ -30122,6 +30162,11 @@
 
 		i = un->sd_fi_fifo_end % SD_FI_MAX_ERROR;
 
+		if (un->sd_fi_fifo_tran[i] != NULL) {
+			ret = EBUSY;
+			break;
+		}
+
 		sd_fault_injection_on = 0;
 
 		/* No more that SD_FI_MAX_ERROR allowed in Queue */
@@ -30134,6 +30179,7 @@
 			    kmem_alloc(sizeof (struct sd_fi_pkt), KM_NOSLEEP);
 			if (un->sd_fi_fifo_pkt[i] == NULL) {
 				/* Alloc failed don't store anything */
+				ret = ENOMEM;
 				break;
 			}
 			rval = ddi_copyin((void *)arg, un->sd_fi_fifo_pkt[i],
@@ -30142,6 +30188,8 @@
 				kmem_free(un->sd_fi_fifo_pkt[i],
 				    sizeof (struct sd_fi_pkt));
 				un->sd_fi_fifo_pkt[i] = NULL;
+				ret = EFAULT;
+				break;
 			}
 		} else {
 			SD_INFO(SD_LOG_IOERR, un,
@@ -30149,6 +30197,67 @@
 		}
 		break;
 
+	case SDIOCINSERTTRAN:
+		/* Store a tran packet struct to be pushed onto fifo. */
+		SD_INFO(SD_LOG_SDTEST, un,
+		    "sd_faultinjection_ioctl: Injecting Fault Insert TRAN\n");
+		i = un->sd_fi_fifo_end % SD_FI_MAX_ERROR;
+
+		/*
+		 * HBA-related fault injections can't be mixed with target-level
+		 * fault injections.
+		 */
+		if (un->sd_fi_fifo_pkt[i] != NULL ||
+		    un->sd_fi_fifo_xb[i] != NULL ||
+		    un->sd_fi_fifo_un[i] != NULL ||
+		    un->sd_fi_fifo_arq[i] != NULL) {
+			ret = EBUSY;
+			break;
+		}
+
+		sd_fault_injection_on = 0;
+
+		if (un->sd_fi_fifo_tran[i] != NULL) {
+			kmem_free(un->sd_fi_fifo_tran[i],
+			    sizeof (struct sd_fi_tran));
+			un->sd_fi_fifo_tran[i] = NULL;
+		}
+		if (arg != NULL) {
+			un->sd_fi_fifo_tran[i] =
+			    kmem_alloc(sizeof (struct sd_fi_tran), KM_NOSLEEP);
+			if (un->sd_fi_fifo_tran[i] == NULL) {
+				/* Alloc failed don't store anything */
+				ret = ENOMEM;
+				break;
+			}
+			rval = ddi_copyin((void *)arg, un->sd_fi_fifo_tran[i],
+			    sizeof (struct sd_fi_tran), 0);
+
+			if (rval == 0) {
+				switch (un->sd_fi_fifo_tran[i]->tran_cmd) {
+					case SD_FLTINJ_CMD_BUSY:
+					case SD_FLTINJ_CMD_TIMEOUT:
+						break;
+					default:
+						ret = EINVAL;
+						break;
+				}
+			} else {
+				ret = EFAULT;
+			}
+
+			if (ret != 0) {
+				kmem_free(un->sd_fi_fifo_tran[i],
+				    sizeof (struct sd_fi_tran));
+				un->sd_fi_fifo_tran[i] = NULL;
+				break;
+			}
+		} else {
+			SD_INFO(SD_LOG_IOERR, un,
+			    "sd_faultinjection_ioctl: tran null\n");
+		}
+		break;
+
 	case SDIOCINSERTXB:
 		/* Store a xb struct to be pushed onto fifo */
 		SD_INFO(SD_LOG_SDTEST, un,
@@ -30156,6 +30265,11 @@
 
 		i = un->sd_fi_fifo_end % SD_FI_MAX_ERROR;
 
+		if (un->sd_fi_fifo_tran[i] != NULL) {
+			ret = EBUSY;
+			break;
+		}
+
 		sd_fault_injection_on = 0;
 
 		if (un->sd_fi_fifo_xb[i] != NULL) {
@@ -30168,6 +30282,7 @@
 			    kmem_alloc(sizeof (struct sd_fi_xb), KM_NOSLEEP);
 			if (un->sd_fi_fifo_xb[i] == NULL) {
 				/* Alloc failed don't store anything */
+				ret = ENOMEM;
 				break;
 			}
 			rval = ddi_copyin((void *)arg, un->sd_fi_fifo_xb[i],
@@ -30177,6 +30292,8 @@
 				kmem_free(un->sd_fi_fifo_xb[i],
 				    sizeof (struct sd_fi_xb));
 				un->sd_fi_fifo_xb[i] = NULL;
+				ret = EFAULT;
+				break;
 			}
 		} else {
 			SD_INFO(SD_LOG_IOERR, un,
@@ -30190,6 +30307,10 @@
 		    "sd_faultinjection_ioctl: Injecting Fault Insert UN\n");
 
 		i = un->sd_fi_fifo_end % SD_FI_MAX_ERROR;
+		if (un->sd_fi_fifo_tran[i] != NULL) {
+			ret = EBUSY;
+			break;
+		}
 
 		sd_fault_injection_on = 0;
 
@@ -30203,6 +30324,7 @@
 			    kmem_alloc(sizeof (struct sd_fi_un), KM_NOSLEEP);
 			if (un->sd_fi_fifo_un[i] == NULL) {
 				/* Alloc failed don't store anything */
+				ret = ENOMEM;
 				break;
 			}
 			rval = ddi_copyin((void *)arg, un->sd_fi_fifo_un[i],
@@ -30211,6 +30333,8 @@
 				kmem_free(un->sd_fi_fifo_un[i],
 				    sizeof (struct sd_fi_un));
 				un->sd_fi_fifo_un[i] = NULL;
+				ret = EFAULT;
+				break;
 			}
 
 		} else {
@@ -30225,6 +30349,10 @@
 		SD_INFO(SD_LOG_SDTEST, un,
 		    "sd_faultinjection_ioctl: Injecting Fault Insert ARQ\n");
 		i = un->sd_fi_fifo_end % SD_FI_MAX_ERROR;
+		if (un->sd_fi_fifo_tran[i] != NULL) {
+			ret = EBUSY;
+			break;
+		}
 
 		sd_fault_injection_on = 0;
 
@@ -30238,6 +30366,7 @@
 			    kmem_alloc(sizeof (struct sd_fi_arq), KM_NOSLEEP);
 			if (un->sd_fi_fifo_arq[i] == NULL) {
 				/* Alloc failed don't store anything */
+				ret = ENOMEM;
 				break;
 			}
 			rval = ddi_copyin((void *)arg, un->sd_fi_fifo_arq[i],
@@ -30246,6 +30375,8 @@
 				kmem_free(un->sd_fi_fifo_arq[i],
 				    sizeof (struct sd_fi_arq));
 				un->sd_fi_fifo_arq[i] = NULL;
+				ret = EFAULT;
+				break;
 			}
 
 		} else {
@@ -30256,7 +30387,7 @@
 		break;
 
 	case SDIOCPUSH:
-		/* Push stored xb, pkt, un, and arq onto fifo */
+		/* Push stored xb, pkt, un, arq and tran onto fifo */
 		sd_fault_injection_on = 0;
 
 		if (arg != NULL) {
@@ -30301,6 +30432,7 @@
 
 	mutex_exit(SD_MUTEX(un));
 	SD_TRACE(SD_LOG_IOERR, un, "sd_faultinjection_ioctl: exit\n");
+	return (ret);
 }
 
 
@@ -30340,7 +30472,56 @@
 	mutex_exit(&(un->un_fi_mutex));
 }
 
+/*
+ * This function is called just before sending the packet to the HBA.
+ * Caller must hold per-LUN mutex. Mutex is held locked upon return.
+ */
+static void
+sd_prefaultinjection(struct scsi_pkt *pktp)
+{
+	uint_t i;
+	struct buf *bp;
+	struct sd_lun *un;
+	struct sd_fi_tran *fi_tran;
 
+	ASSERT(pktp != NULL);
+
+	/* pull bp and un from pktp */
+	bp = (struct buf *)pktp->pkt_private;
+	un = SD_GET_UN(bp);
+
+	/* if injection is off return */
+	if (sd_fault_injection_on == 0 ||
+	    un->sd_fi_fifo_start == un->sd_fi_fifo_end) {
+		return;
+	}
+
+	ASSERT(un != NULL);
+	ASSERT(mutex_owned(SD_MUTEX(un)));
+
+	/* take next set off fifo */
+	i = un->sd_fi_fifo_start % SD_FI_MAX_ERROR;
+
+	fi_tran = un->sd_fi_fifo_tran[i];
+	if (fi_tran != NULL) {
+		switch (fi_tran->tran_cmd) {
+			case SD_FLTINJ_CMD_BUSY:
+				pktp->pkt_flags |= FLAG_PKT_BUSY;
+				break;
+			case SD_FLTINJ_CMD_TIMEOUT:
+				pktp->pkt_flags |= FLAG_PKT_TIMEOUT;
+				break;
+			default:
+				return;
+		}
+	}
+	/*
+	 * We don't deallocate any data here - it will be deallocated after
+	 * the packet has been processed by the HBA.
+	 */
+}
+
+
 /*
  *    Function: sd_faultinjection()
  *
@@ -30565,15 +30746,12 @@
  *     As section 3 says, sd checks if some kinds of devices have VTOC label.
  *     If those devices have no valid VTOC label, sd(7d) will attempt to
  *     create default VTOC for them. Currently sd creates default VTOC label
- *     for all devices on x86 platform (VTOC_16), but only for removable
- *     media devices on SPARC (VTOC_8).
+ *     for all devices on x86 platform (VTOC_16).
  *
  *     -----------------------------------------------------------
  *       removable media hotpluggable platform   |   Default Label
  *     -----------------------------------------------------------
- *             false          false    sparc     |     No
  *             false          true      x86      |     Yes
- *             false          true     sparc     |     Yes
  *             true             x        x       |     Yes
  *     ----------------------------------------------------------
  *
@@ -30606,35 +30784,23 @@
  *
  * 7. fdisk partition management
  *
- *     Fdisk is traditional partition method on x86 platform. Sd(7d) driver
- *     just supports fdisk partitions on x86 platform. On sparc platform, sd
- *     doesn't support fdisk partitions at all. Note: pcfs(7fs) can recognize
- *     fdisk partitions on both x86 and SPARC platform.
+ *     Fdisk is traditional partition method on x86 platform. sd(7D) driver
+ *     just supports fdisk partitions on x86 platform.
  *
  *     -----------------------------------------------------------
  *       platform   removable media  USB/1394  |  fdisk supported
  *     -----------------------------------------------------------
  *        x86         X               X        |       true
- *     ------------------------------------------------------------
- *        sparc       X               X        |       false
- *     ------------------------------------------------------------
+ *     -----------------------------------------------------------
  *
  *
  * 8. MBOOT/MBR
  *
- *     Although sd(7d) doesn't support fdisk on SPARC platform, it does support
- *     read/write mboot for removable media devices on sparc platform.
- *
  *     -----------------------------------------------------------
  *       platform   removable media  USB/1394  |  mboot supported
  *     -----------------------------------------------------------
  *        x86         X               X        |       true
- *     ------------------------------------------------------------
- *        sparc      false           false     |       false
- *        sparc      false           true      |       true
- *        sparc      true            false     |       true
- *        sparc      true            true      |       true
- *     ------------------------------------------------------------
+ *     -----------------------------------------------------------
  *
  *
  * 9.  error handling during opening device
@@ -31172,13 +31338,9 @@
  *
  *    Context: Kernel thread or interrupt context.
  */
-
-#define	DEVID_IF_KNOWN(d) "devid", DATA_TYPE_STRING, (d) ? (d) : "unknown"
-
 static void
 sd_ssc_ereport_post(sd_ssc_t *ssc, enum sd_driver_assessment drv_assess)
 {
-	int uscsi_path_instance = 0;
 	uchar_t	uscsi_pkt_reason;
 	uint32_t uscsi_pkt_state;
 	uint32_t uscsi_pkt_statistics;
@@ -31221,7 +31383,6 @@
 		return;
 
 	uscsi_pkt_reason = ssc->ssc_uscsi_info->ui_pkt_reason;
-	uscsi_path_instance = ssc->ssc_uscsi_cmd->uscsi_path_instance;
 	uscsi_pkt_state = ssc->ssc_uscsi_info->ui_pkt_state;
 	uscsi_pkt_statistics = ssc->ssc_uscsi_info->ui_pkt_statistics;
 	uscsi_ena = ssc->ssc_uscsi_info->ui_ena;
@@ -31270,7 +31431,7 @@
 	 * driver-assessment will always be "recovered" here.
 	 */
 	if (drv_assess == SD_FM_DRV_RECOVERY) {
-		scsi_fm_ereport_post(un->un_sd, uscsi_path_instance, NULL,
+		scsi_fm_ereport_post(un->un_sd, 0, NULL,
 		    "cmd.disk.recovered", uscsi_ena, devid, NULL,
 		    DDI_NOSLEEP, NULL,
 		    FM_VERSION, DATA_TYPE_UINT8, FM_EREPORT_VERS0,
@@ -31297,7 +31458,7 @@
 	 */
 	if (ssc->ssc_flags & ssc_invalid_flags) {
 		if (ssc->ssc_flags & SSC_FLAGS_INVALID_SENSE) {
-			scsi_fm_ereport_post(un->un_sd, uscsi_path_instance,
+			scsi_fm_ereport_post(un->un_sd, 0,
 			    NULL, "cmd.disk.dev.uderr", uscsi_ena, devid,
 			    NULL, DDI_NOSLEEP, NULL,
 			    FM_VERSION, DATA_TYPE_UINT8, FM_EREPORT_VERS0,
@@ -31326,7 +31487,7 @@
 			 * un-decodable content could be seen from upper
 			 * level payload or inside un-decode-info.
 			 */
-			scsi_fm_ereport_post(un->un_sd, uscsi_path_instance,
+			scsi_fm_ereport_post(un->un_sd, 0,
 			    NULL,
 			    "cmd.disk.dev.uderr", uscsi_ena, devid,
 			    NULL, DDI_NOSLEEP, NULL,
@@ -31368,7 +31529,7 @@
 		if (ssc->ssc_flags & SSC_FLAGS_TRAN_ABORT)
 			ssc->ssc_flags &= ~SSC_FLAGS_TRAN_ABORT;
 
-		scsi_fm_ereport_post(un->un_sd, uscsi_path_instance, NULL,
+		scsi_fm_ereport_post(un->un_sd, 0, NULL,
 		    "cmd.disk.tran", uscsi_ena, NULL, NULL, DDI_NOSLEEP, NULL,
 		    FM_VERSION, DATA_TYPE_UINT8, FM_EREPORT_VERS0,
 		    DEVID_IF_KNOWN(devid),
@@ -31412,7 +31573,7 @@
 				 * drv_assess is SD_FM_DRV_FATAL.
 				 */
 				scsi_fm_ereport_post(un->un_sd,
-				    uscsi_path_instance, NULL,
+				    0, NULL,
 				    "cmd.disk.dev.rqs.merr",
 				    uscsi_ena, devid, NULL, DDI_NOSLEEP, NULL,
 				    FM_VERSION, DATA_TYPE_UINT8,
@@ -31461,7 +31622,7 @@
 				 * SD_FM_DRV_FATAL.
 				 */
 				scsi_fm_ereport_post(un->un_sd,
-				    uscsi_path_instance, NULL,
+				    0, NULL,
 				    "cmd.disk.dev.rqs.derr",
 				    uscsi_ena, devid,
 				    NULL, DDI_NOSLEEP, NULL,
@@ -31516,7 +31677,7 @@
 			 * driver-assessment will be set based on parameter
 			 * drv_assess.
 			 */
-			scsi_fm_ereport_post(un->un_sd, uscsi_path_instance,
+			scsi_fm_ereport_post(un->un_sd, 0,
 			    NULL,
 			    "cmd.disk.dev.serr", uscsi_ena,
 			    devid, NULL, DDI_NOSLEEP, NULL,
@@ -31770,10 +31931,13 @@
 		} else {
 			if (!ISP2(pbsize % DEV_BSIZE) || pbsize == 0) {
 				un->un_phy_blocksize = DEV_BSIZE;
-			} else if (pbsize > un->un_phy_blocksize) {
+			} else if (pbsize > un->un_phy_blocksize &&
+			    !un->un_f_sdconf_phy_blocksize) {
 				/*
-				 * Don't reset the physical blocksize
-				 * unless we've detected a larger value.
+				 * Reset the physical block size
+				 * if we've detected a larger value and
+				 * we didn't already set the physical
+				 * block size in sd.conf
 				 */
 				un->un_phy_blocksize = pbsize;
 			}
